//----------------------------------------------------------------------------------
// aviutl  GPUJX^tB^p ̂ق̊֐
// Copyright (c) 2008  N099
//----------------------------------------------------------------------------------
#pragma once

//ϊRs[pp[^
struct CpCvtParam {
	void *buf;
	PIXEL_YC *pyc;
	unsigned int h, w;
	unsigned int sbuf, spyc; //@byte, @pixel
};

class CpCvt {
public:
	//mt counter
	static volatile long s_cmt;

	typedef void (* CPCVTF)(const CpCvtParam&);
	enum CpCvtFmt { FLOAT32, FLOAT16, INT16, BIASED16, UNKNOWN };

	static bool GetCpConverter(CpCvt* &cc, CpCvtFmt fmt);
	MULTI_THREAD_FUNC GetYCtoX();
	MULTI_THREAD_FUNC GetXtoYC();
	void ProcYCtoX(const CpCvtParam &p) const { m_yc2xx(p); }
	void ProcXtoYC(const CpCvtParam &p) const { m_xx2yc(p); }
private:
	CpCvt() : m_yc2xx_mt(NULL), m_xx2yc_mt(NULL), m_yc2xx(NULL), m_xx2yc(NULL) {}
	CpCvt(MULTI_THREAD_FUNC f, MULTI_THREAD_FUNC g, CPCVTF d, CPCVTF e)
		: m_yc2xx_mt(f), m_xx2yc_mt(g), m_yc2xx(d), m_xx2yc(e) {}
	
	//convert function pointers
	MULTI_THREAD_FUNC m_yc2xx_mt;
	MULTI_THREAD_FUNC m_xx2yc_mt;
	CPCVTF m_yc2xx;
	CPCVTF m_xx2yc;
};

