//----------------------------------------------------------------------------------
// aviutl  GPUJX^tB^ D3DXHANDLEǗ\
// Copyright (c) 2007-2009  N099
//----------------------------------------------------------------------------------
#pragma once
#include <algorithm>

//nhǗp
struct TrackHandle {
	D3DXHANDLE handle;
	int max;
	int min;
	int usage;
	int abs_max;
};

struct CheckHandle {
	D3DXHANDLE handle;
	int usage;
};

struct TxSrcHandle {
	D3DXHANDLE handle;
	int offset;
};

struct KernelHandle {
	D3DXHANDLE pix;
	D3DXHANDLE tex;
	int size;
};

class RtTbl {
public:
	static const size_t rt_max = 4;
	RtTbl() { std::fill(tbl, tbl + rt_max, -1); }
	int& operator[](size_t pos) { return tbl[pos]; }
	const int& operator[](size_t pos) const { return tbl[pos]; }
	int count(int c) const { return std::count(tbl, tbl + rt_max, c); }
private:
	int tbl[rt_max];
};

struct TechHandle {
	D3DXHANDLE handle;
	int npass;
	std::vector<RtTbl> rt;
};
